\version "2.14.0"

\header {
  texidoc = "
This snippet defines a function, mixedMeter, that can be used to make
subdivided time signatures. It automatically sets the measure length
and beam grouping correctly. For now, the implementation is really
ugly. Hopefully somebody can clean up.

If the function is saved in mixed-meter.ly then the given example would
be entered as

\\include \"mixed-meter.ly\" @{
  \\mixedMeter #'(3 2 2 3 8)
  \\repeat unfold 10 c'8 \\repeat unfold 20 c'16 @}

"
  doctitle = "Mixed Meter - automatic compound time signatures"
}

#(define (compound-time . args)
  (let* ((revargs (reverse args))
         (den (car revargs))
         (nums (reverse (cdr revargs))))
   (make-override-markup
    '(baseline-skip . 0)
    (make-number-markup
     (make-line-markup
      (cons
       (make-column-markup (list (car nums) den))
       (map (lambda (num)
             (make-line-markup (list
                                (make-vcenter-markup "+")
                                (make-column-markup (list num den)))))
        (cdr nums))))))))

#(define (sum-list lst)
  (if (pair? lst)
      (+ (car lst) (sum-list (cdr lst)))
      0))

mixedMeter =
#(define-music-function (parser location args) (pair?)
  #{
     #(let* ((revargs (reverse $args))
             (den (car revargs))
             (nums (reverse (cdr revargs))))

        (ly:export
          (make-music
            'TimeSignatureMusic
            'beat-structure nums
            'denominator den
            'numerator (sum-list (cdr revargs)))))

    \override Staff.TimeSignature #'stencil = #ly:text-interface::print
    \override Staff.TimeSignature #'text = #(apply compound-time (map number->string $args))
  #})

%%% CUT HERE!
{
  \mixedMeter #'(3 2 2 3 8)
  \repeat unfold 10 c'8 \repeat unfold 20 c'16
}



